OGRE: Ogre::VectorIteratorWrapper< T, IteratorType > Class Template Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Attributes

# Ogre::VectorIteratorWrapper< T, IteratorType > Class Template Reference

Prepiared IteratorWrapper for container like std::vector. More...

`#include <OgreIteratorWrapper.h>`

Inheritance diagram for Ogre::VectorIteratorWrapper< T, IteratorType >:
[legend]

List of all members.

## Public Types
typedef IteratorWrapper< T, IteratorType, typename T::value_type >::ValueType | ValueType
| type you expect to get by funktions like peekNext(Value)
typedef IteratorWrapper< T, IteratorType, typename T::value_type >::PointerType | PointerType
| type you expect to get by funktions like peekNext(Value)Ptr
typedef IteratorType | iterator
| typedef to fulfill container interface
typedef IteratorType | const_iterator
| typedef to fulfill container interface
## Public Member Functions
| VectorIteratorWrapper (IteratorType start, IteratorType last)
| c'tor
ValueType | peekNext () const
| Returns the next(=current) element in the collection, without advancing to the next.
PointerType | peekNextPtr () const
| Returns a pointer to the next(=current) element in the collection, without advancing to the next afterwards.
ValueType | getNext ()
| Returns the next(=current) value element in the collection, and advances to the next.
bool | hasMoreElements () const
| Returns true if there are more items in the collection.
void | moveNext ()
| Moves the iterator on one element.
const IteratorType & | begin ()
| bookmark to the begin of the underlying collection
IteratorType & | current ()
| full access to the current iterator
const IteratorType & | end ()
| bookmark to the end (one behind the last element) of the underlying collection
## Protected Attributes
IteratorType | mBegin
IteratorType | mCurrent
IteratorType | mEnd

## Detailed Description

### template<typename T, typename IteratorType>
class Ogre::VectorIteratorWrapper< T, IteratorType >

Prepiared IteratorWrapper for container like std::vector.

Parameters:

  | T | = Container eg vector
  | IteratorType | T::iterator or T::const_iterator

have a look at VectorIterator and ConstVectorIterator for a more concrete usage

Definition at line 137 of file OgreIteratorWrapper.h.

## Member Typedef Documentation

typedef IteratorType Ogre::IteratorWrapper< T, IteratorType, T::value_type >::const_iterator`[inherited]`

typedef to fulfill container interface

Userfull if you want to use BOOST_FOREACH

Note:
  there is no distinction between const_iterator and iterator.
  keep this in mind if you want to derivate from this class.

Definition at line 82 of file OgreIteratorWrapper.h.

typedef IteratorType Ogre::IteratorWrapper< T, IteratorType, T::value_type >::iterator`[inherited]`

typedef to fulfill container interface

Userfull if you want to use BOOST_FOREACH

Note:
  there is no distinction between const_iterator and iterator.
  keep this in mind if you want to derivate from this class.

Definition at line 73 of file OgreIteratorWrapper.h.

template<typename T, typename IteratorType>

typedef IteratorWrapper<T, IteratorType, typename T::value_type>::PointerType Ogre::VectorIteratorWrapper< T, IteratorType >::PointerType

type you expect to get by funktions like peekNext(Value)Ptr

Reimplemented from Ogre::IteratorWrapper< T, IteratorType, T::value_type >.

Definition at line 142 of file OgreIteratorWrapper.h.

template<typename T, typename IteratorType>

typedef IteratorWrapper<T, IteratorType, typename T::value_type>::ValueType Ogre::VectorIteratorWrapper< T, IteratorType >::ValueType

type you expect to get by funktions like peekNext(Value)

Reimplemented from Ogre::IteratorWrapper< T, IteratorType, T::value_type >.

Definition at line 141 of file OgreIteratorWrapper.h.

## Constructor & Destructor Documentation

template<typename T, typename IteratorType>

Ogre::VectorIteratorWrapper< T, IteratorType >::VectorIteratorWrapper | ( | IteratorType | start,
|  | IteratorType | last |
| ) |  |  |

c'tor

Constructor that provide a start and end iterator to initialise.

Parameters:

  | start | start iterator
  | end | end iterator

Definition at line 153 of file OgreIteratorWrapper.h.

## Member Function Documentation

const IteratorType& Ogre::IteratorWrapper< T, IteratorType, T::value_type >::begin | ( |  | ) | `[inherited]`

bookmark to the begin of the underlying collection

Definition at line 112 of file OgreIteratorWrapper.h.

IteratorType& Ogre::IteratorWrapper< T, IteratorType, T::value_type >::current | ( |  | ) | `[inherited]`

full access to the current iterator

Definition at line 116 of file OgreIteratorWrapper.h.

const IteratorType& Ogre::IteratorWrapper< T, IteratorType, T::value_type >::end | ( | void |  | ) | `[inherited]`

bookmark to the end (one behind the last element) of the underlying collection

Definition at line 119 of file OgreIteratorWrapper.h.

template<typename T, typename IteratorType>

ValueType Ogre::VectorIteratorWrapper< T, IteratorType >::getNext | ( |  | ) |

Returns the next(=current) value element in the collection, and advances to the next.

Definition at line 172 of file OgreIteratorWrapper.h.

bool Ogre::IteratorWrapper< T, IteratorType, T::value_type >::hasMoreElements | ( |  | ) | const`[inherited]`

Returns true if there are more items in the collection.

Definition at line 99 of file OgreIteratorWrapper.h.

void Ogre::IteratorWrapper< T, IteratorType, T::value_type >::moveNext | ( |  | ) | `[inherited]`

Moves the iterator on one element.

Definition at line 106 of file OgreIteratorWrapper.h.

template<typename T, typename IteratorType>

ValueType Ogre::VectorIteratorWrapper< T, IteratorType >::peekNext | ( |  | ) | const

Returns the next(=current) element in the collection, without advancing to the next.

Definition at line 160 of file OgreIteratorWrapper.h.

template<typename T, typename IteratorType>

PointerType Ogre::VectorIteratorWrapper< T, IteratorType >::peekNextPtr | ( |  | ) | const

Returns a pointer to the next(=current) element in the collection, without advancing to the next afterwards.

Definition at line 166 of file OgreIteratorWrapper.h.

## Member Data Documentation

IteratorType Ogre::IteratorWrapper< T, IteratorType, T::value_type >::mBegin`[protected, inherited]`

Definition at line 54 of file OgreIteratorWrapper.h.

IteratorType Ogre::IteratorWrapper< T, IteratorType, T::value_type >::mCurrent`[protected, inherited]`

Definition at line 55 of file OgreIteratorWrapper.h.

Referenced by Ogre::VectorIteratorWrapper< T, T::const_iterator >::getNext(), Ogre::VectorIteratorWrapper< T, T::const_iterator >::peekNext(), and Ogre::VectorIteratorWrapper< T, T::const_iterator >::peekNextPtr().

IteratorType Ogre::IteratorWrapper< T, IteratorType, T::value_type >::mEnd`[protected, inherited]`

Definition at line 56 of file OgreIteratorWrapper.h.

The documentation for this class was generated from the following file:

- OgreIteratorWrapper.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56